/*******************************************************************************
*
*  Web Vengeance Poo Pack - main.h
*
*  Header file for the Poo pack.
*  Contains global structure definitions and variables shared by all effects
*  in this pack. 
*
*	Copyright (c) 1997 SegaSoft, Inc.  All Rights Reserved.
*
*------------------------------------------------------------------------------
*                   CONFIDENTIAL AND PROPRIETARY INFORMATION
*------------------------------------------------------------------------------
*  The contents of this file are the property of SegaSoft, Inc., 
*  and may not be used or duplicated without the permission of SegaSoft, Inc.
*------------------------------------------------------------------------------
*
*  Edit History:
*		97-Sep-29	DJS	Creation.
*
*  Initials:
*  	DJS	Dan J. Su
*
*******************************************************************************/
#ifndef MAIN_H
#define MAIN_H


#ifdef EXTERN
#undef EXTERN
#endif

#ifdef DEFINE_MAIN
   #define EXTERN
#else
   #define EXTERN extern
#endif


// ---------- Defines
   // ----- FXOBJECT IDs
#define FX_ID_CURSOR             ( -1 )   // ID of cursor FXOBJECT ( Defined as MOUSE_CURSOR in old WV packs )
#define FX_ID_DEFENSE            ( -2 )   // ID of defense FXOBJECT, not necessarily unique


   // ----- Bounding box offsets for the umbrella bitmap
#define DEFENSE_X1               (  35 )
#define DEFENSE_X2               ( 220 )
#define DEFENSE_Y1               (  35 )
#define DEFENSE_Y2               ( 220 )

   // OK to draw chips, scratches, dents, etc in this box on the umbrella bitmap
#define DEFENSE_DRAW_X1          ( DEFENSE_X1 )
#define DEFENSE_DRAW_X2          ( DEFENSE_X2 )
#define DEFENSE_DRAW_Y1          ( DEFENSE_Y1 )
#define DEFENSE_DRAW_Y2          ( DEFENSE_Y2 )


// ---------- Function Prototypes
EXTERN int  InitEffects    ( void );


// ---------- Global Variables
EXTERN FXOBJECT      g_fxCursor;                            // Cursor sprite
EXTERN DEFENSE       g_defense;                             // Defense object, nFlags used for state, dwFlags used as an ERASE flag


#endif   // MAIN_H


