#define URLBLASTER						__declspec( dllimport ) extern

#define PLAYER_ONE		1
#define PLAYER_TWO		2

#define MAX_WAVES			   16
#define LOOP_FOREVER		   0
#define WAVE_DONE			   1       // Wave has finished playing
#define WAVE_LOADED			   2       // Wave has been loaded, but not yet played
#define WAVE_PLAYING		   3       // Wave is currently playing


#define EFFECT_NOT_FOUND				-1
#define NO_EFFECTS_REGISTERED			-2
#define ERROR_LOADING_IMAGE				-3
#define EFFECT_STARTED					1
#define EFFECT_ENDED					2
#define URL_CHANGED						3
#define SEND_NETWORK_DATA				4
#define GET_NETWORK_DATA				5
#define	SHIFT_OFFENSE					6
#define DRAW_CREDITS					7	

#define MAXCREDITLENGTH					50

#define AUTO_MODE						0
#define MANUAL_MODE						1
#define MANUAL_DRAW_TO_BROWSER			1
#define MANUAL_LOADED_EFFECT_DATA		2
#define MANUAL_SAVE_EFFECT_DATA			3
	
#define DRAW_EFFECT						1
#define CALCULATE_AND_SKIP_FRAME		2
#define	DRAW_NETWORK_EFFECT				3
#define DRAW_DUALMODE_OBJECT_TO_BUFFER	4
#define DRAW_DUALMODE_OBJECT_TO_SCREEN	5
#define ERASE_DUALMODE_OBJECT_IN_BUFFER 6

#define SHIFT_OBJECT_NONE				0
#define SHIFT_OBJECT_TO_TOP_SCREEN		1
#define SHIFT_OBJECT_TO_BOTTOM_SCREEN	2

#define CENTER_TEX(a,b) (a - (b>>1))

#define FLIP_HORIZONTAL					0x0001
#define FLIP_VERTICAL					0x0002
#define SCALE_IMAGE						0x0004
#define ROTATE_IMAGE					0x0008
#define DRAW_IN_BROWSER					0x0010
#define FAST_TRANSLUCENT_IMAGE			0x0100
#define FADE_TRANSLUCENT_IMAGE			0x0200


#define FIND_FIRST_OBJECT				0x01
#define FIND_NEXT_OBJECT				0x02

#define FX_ALL							0
#define FX_NETWORK_OBJECT				1

#define CREDIT_TITLE		0
#define CREDIT_NAME			1
#define CREDIT_PACK_NAME	10

#define GET_SCREEN_CAPTURE			0
#define GET_OFFSCREEN_BUFFER		1
#define GET_FRONT_BUFFER			2


typedef struct _FXObject
{	

	int nType;						//Type of Object
	int x, y, z;						//x & y position
	float fScaleX, fScaleY;         
    float fAngle, fTranslucent;     //Rotate Image n Degree's - Used by Web Vengeance Set by Effect Pack
									//fTranslucent = percentage of translucentcy 0-100 0 = image invisible  and 100 = image complely visible Used by Web Vengeance Set by Effect Pack
	int nFrame;						//Current Frame   - Used and Set by Effect Pack
	int nFrameTime;					//Counter for the Duration a current frame - Used and Set by Effect Pack
	int nInsideBrowser;				//Specifies if any portion of object is inside browsers client area
	int nFlags;						//Extra int for the user.
	DWORD dwFlags;					//Extra User Info
	DWORD dwFlags2;					//Extra User info
	BYTE byShiftFlag;				//Dual Mode shifting
    int nReserved;					//Used internally by Web Vengeance do not alter
    RECT rReserved1;					//Used internally by Web Vengeance do not alter
    RECT rReserved2;				//Used internally by Web Vengeance do not alter

} FXOBJECT;


typedef short PIXEL;

typedef struct {

	HWND hwnd;
	LPDIRECTDRAW  lpDD;
	DDSURFACEDESC ddsd, front_ddsd, back_ddsd;
    DDSCAPS  ddscaps;
	LPDIRECTDRAWSURFACE lpFrontBuffer, lpBackBuffer;

} DDRAW_DATA;

typedef struct {

	int width, height;
	int pitch;
	int width_mask, height_mask;
	int width_shifts;
	short Palette16[256];
	long Palette24[256];
	PIXEL *data;

} TEXTURE;

typedef struct {

	int width, height;
	int pitch;
	PIXEL *data;

} BITMAP1;

typedef struct _URLINFO
{

	int nType;
	long nSize;  //URL data size in bytes
	void* ptrData;

} URLDATA;

typedef struct _DPDATA
{
	DWORD dwSize;
	void* pvData;
} DPDATA;

typedef int   FXP;

typedef struct {

	FXP x, y;

} FXP_POINT;

typedef struct {

	int red, green, blue;

} INT_RGB;

typedef struct {

	int x, y;

} INT_POINT;


typedef int (*MANUALEFFECT) (DDRAW_DATA *dd_data, int, void*);
typedef int (*FXFUNCTION) (DDRAW_DATA *dd_data, int);
typedef int (*ENDFXFUNCTION) (DDRAW_DATA *dd_data, int, int, int);
typedef int (*DUALMODE) (DDRAW_DATA *dd_data, int, int);

int RegisterEffect(char *EffectName, char *DLLName, FXFUNCTION EffectFunction, ENDFXFUNCTION EndEffectFunction, char *TextureName, 
				   MANUALEFFECT ManualEffect, DUALMODE DualMode);

int GetEffectName(int nType, char *EffectName);
int GetEffectMenuName(int nType, char *EffectMenuName);
int GetEffect(int nID);
int FindEffect(char *EffectName);
FXOBJECT* CreateFXObject();
FXOBJECT* GetNextFXObject(int nType, int nFlags);
int GetTotalFXObjectsForEffect(int nType);
BOOL LoadTexture(DDRAW_DATA* dd_data,LPCTSTR lpFileName,TEXTURE* bitmap);
void InitObject(int nObjectType, FXOBJECT *FXObject, TEXTURE *texture, int nX, int nY);
void MoveObjectTo(FXOBJECT *TGAObject, int x, int y);
void EraseObjectInBuffer (DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture);
void EraseObjectOnScreen(DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture);
void DrawBufferObjectToScreen(DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture);
void DrawScaleObjectToScreen(DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture);
int  DrawBufferObjectToBrowser(DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture);
void DeleteTexture(TEXTURE *texture);
void EraseTrackedBuffer(DDRAW_DATA *dd_data);
void DrawTrackedBufferToScreen(DDRAW_DATA *dd_data);
void EraseRectInBuffer(DDRAW_DATA *dd_data, RECT *rDest);
void EraseRectOnScreen(DDRAW_DATA *dd_data, RECT *rDest);
void DrawObjectToBuffer (DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture, int nFlags);
void DrawObjectToScreenCapture (DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture, int nFlags);
int DrawObjectToBrowserBuffer(DDRAW_DATA *dd_data, FXOBJECT *FXObject, TEXTURE *texture, int nFlags);
void DrawAndTrackObjectToBuffer (DDRAW_DATA *dd_data, FXOBJECT *TGAObject, TEXTURE *texture, int nFlags);
int LoadWave(char *FileName);
int PlayWave(int nWave);
int PlayWaveEx(int Wave, int nLoopTimes);
int StopWave(int nWave);
signed long GetWaveStatus(int nWave);
int DeleteWaves();
int GetNetworkData(void* vData, DWORD *dwSize);
int SendNetworkData(void* pvNetData, DWORD dwSize);
void ShiftFXObject(FXOBJECT *fxObject, BYTE byFlags);
int SetDefendedRect(RECT *r, TEXTURE *tex);
void* WasRectDefended(RECT *r);
void CopyFXObject(FXOBJECT *fxDest, FXOBJECT *fxSrc, int nFlags);
void DrawTextureInTexture(TEXTURE *srcTex, TEXTURE *destTex, POINT *pt);
void DeleteLastFXObject(void);
void ResetCode(void);
int DrawCredit(char *str, BYTE byType);
int DeleteFXObject(FXOBJECT *fxObject);
BITMAP1 * GetScreenBuffer(BYTE byType, DDRAW_DATA *dd_data);
DWORD GetBlasterDLLVersion();

URLBLASTER int		nScreenWidth, nScreenHeight;
URLBLASTER int		nMouseX, nMouseY;
URLBLASTER boolean	LButtonPressed;      //tells if the user pressed the left mouse button
URLBLASTER boolean	LButtonReleased;
URLBLASTER int		nLButtonDownX, nLButtonDownY;
URLBLASTER int		nLButtonUpX, nLButtonUpY;
URLBLASTER boolean	RButtonPressed;      //tells if the user pressed the left mouse button
URLBLASTER boolean	RButtonReleased;
URLBLASTER int		nRButtonDownX, nRButtonDownY;
URLBLASTER int		nRButtonUpX, nRButtonUpY;
URLBLASTER int		nEffectsDefended;
URLBLASTER BYTE		bySendDPData;
URLBLASTER BYTE		byGetDPData;
URLBLASTER void*	pvDPData;
URLBLASTER BYTE		byShiftObject;  //used to determine if the object should be shifted up or down in network mode
URLBLASTER char		szCode[10];
